Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_transition.cpp	(revision 117)
@@ -242,5 +242,8 @@
 
 	for (uint32_t i=0; i< _param->_size_store_queue             ; i++)
+          {
+          reg_STORE_QUEUE_NB_CHECK  [i] = 0;
 	  _store_queue              [i]._state = STORE_QUEUE_EMPTY;
+          }
 
 	for (uint32_t i=0; i< _param->_size_load_queue              ; i++)
@@ -252,4 +255,72 @@
     else
       {
+	//================================================================
+	// Interface "MEMORY_OUT"
+	//================================================================
+
+        if ((    internal_MEMORY_OUT_VAL  == 1) and
+            (PORT_READ(in_MEMORY_OUT_ACK[0]) == 1))
+          {
+	    log_printf(TRACE,Load_store_unit,FUNCTION,"  * MEMORY_OUT[0] transaction");
+
+	    switch (internal_MEMORY_OUT_SELECT_QUEUE)
+	      {
+	      case SELECT_STORE_QUEUE :
+		{
+		  // =======================
+		  // ===== STORE_QUEUE =====
+		  // =======================
+		  
+		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * store_queue [%d]",reg_STORE_QUEUE_PTR_READ);
+	    
+		  // Entry flush and increase the read pointer
+		  _store_queue [reg_STORE_QUEUE_PTR_READ]._state = STORE_QUEUE_EMPTY;
+		  
+		  reg_STORE_QUEUE_PTR_READ = (reg_STORE_QUEUE_PTR_READ+1)%_param->_size_store_queue;
+
+		  break;
+		}
+	      case SELECT_LOAD_QUEUE :
+		{
+		  // ======================
+		  // ===== LOAD_QUEUE =====
+		  // ======================
+		  
+		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * load_queue  [%d]",internal_MEMORY_OUT_PTR);
+		  
+		  // Entry flush and increase the read pointer
+		  
+		  _load_queue [internal_MEMORY_OUT_PTR]._state = LOAD_QUEUE_EMPTY;
+		  
+		  // reg_LOAD_QUEUE_PTR_READ = (reg_LOAD_QUEUE_PTR_READ+1)%_param->_size_load_queue;
+
+		  break;
+		}
+	      case SELECT_LOAD_QUEUE_SPECULATIVE :
+		{
+		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * load_queue  [%d] (speculative)",internal_MEMORY_OUT_PTR);
+		  
+                  // !!! WARNING !!!
+                  // !!! Test special case :
+                  // !!! in a cycle an instruction can check the last store AND commit instruction
+                  // !!! also the memory_out is before the port_check
+
+		  _load_queue [internal_MEMORY_OUT_PTR]._state    = LOAD_QUEUE_CHECK;
+		  // NOTE : a speculative load write in the register file.
+		  // if the speculation is a miss, write_rd is re set at 1.
+		  _load_queue [internal_MEMORY_OUT_PTR]._write_rd = 0;
+
+#ifdef STATISTICS
+                  if (usage_is_set(_usage,USE_STATISTICS))
+                    (*_stat_nb_inst_load_commit_speculative) ++;
+#endif
+
+		  break;
+		}
+
+		break;
+	      }
+	  }
+
 	//================================================================
 	// Interface "PORT_CHECK"
@@ -278,5 +349,7 @@
 
 		// find a entry that it need a check
-		Tlsq_ptr_t index_store  = _load_queue[index_load]._store_queue_ptr_write;
+		Tlsq_ptr_t index_store     = _load_queue[index_load]._store_queue_ptr_write;
+		Tlsq_ptr_t index_store_old = index_store;
+
                 // Init variable
 		bool       end_check    = false;
@@ -534,4 +607,5 @@
 				  // The check is finish if all bit is set
 				  end_check = (_load_queue[index_load]._check_hit_byte == _param->_mask_check_hit_byte);
+
 				}
 			    }
@@ -553,4 +627,12 @@
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"              * next");
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * new store_queue_ptr_write : %d",index_store);
+
+		    log_printf(TRACE,Load_store_unit,FUNCTION,"              * update reg_STORE_QUEUE_NB_CHECK");
+#ifdef DEBUG
+                    if (reg_STORE_QUEUE_NB_CHECK [index_store] == 0)
+                      throw ERRORMORPHEO(FUNCTION,_("reg_STORE_QUEUE_NB_CHECK must be > 0\n"));
+#endif
+                    reg_STORE_QUEUE_NB_CHECK [index_store] --;
+
 // 		    if (_load_queue[index_load]._store_queue_ptr_write == 0)
 // 		      _load_queue[index_load]._store_queue_ptr_write = _param->_size_store_queue-1;
@@ -615,4 +697,23 @@
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * state new : %s",toString(_load_queue[index_load]._state).c_str());
 		    log_printf(TRACE,Load_store_unit,FUNCTION,"                * exception : %d",_load_queue[index_load]._exception);
+
+                    if (end_check)
+                      {
+                        log_printf(TRACE,Load_store_unit,FUNCTION,"                * end check, decrease all nb_check");
+                        
+                        uint32_t i=index_store;
+                        while (i!=reg_STORE_QUEUE_PTR_READ)
+                          {
+                            i=((i==0)?_param->_size_store_queue:i)-1;
+                            
+#ifdef DEBUG
+                            if (reg_STORE_QUEUE_NB_CHECK [i] == 0)
+                              throw ERRORMORPHEO(FUNCTION,_("reg_STORE_QUEUE_NB_CHECK must be > 0\n"));
+#endif
+                            
+                            reg_STORE_QUEUE_NB_CHECK [i] --;
+                            //i=(i+1)%_param->_size_store_queue;
+                          }
+                      }
 		  }
 	      }
@@ -803,67 +904,4 @@
 
 	//================================================================
-	// Interface "MEMORY_OUT"
-	//================================================================
-
-        if ((    internal_MEMORY_OUT_VAL  == 1) and
-            (PORT_READ(in_MEMORY_OUT_ACK[0]) == 1))
-          {
-	    log_printf(TRACE,Load_store_unit,FUNCTION,"  * MEMORY_OUT[0] transaction");
-
-	    switch (internal_MEMORY_OUT_SELECT_QUEUE)
-	      {
-	      case SELECT_STORE_QUEUE :
-		{
-		  // =======================
-		  // ===== STORE_QUEUE =====
-		  // =======================
-		  
-		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * store_queue [%d]",reg_STORE_QUEUE_PTR_READ);
-	    
-		  // Entry flush and increase the read pointer
-		  _store_queue [reg_STORE_QUEUE_PTR_READ]._state = STORE_QUEUE_EMPTY;
-		  
-		  reg_STORE_QUEUE_PTR_READ = (reg_STORE_QUEUE_PTR_READ+1)%_param->_size_store_queue;
-
-		  break;
-		}
-	      case SELECT_LOAD_QUEUE :
-		{
-		  // ======================
-		  // ===== LOAD_QUEUE =====
-		  // ======================
-		  
-		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * load_queue  [%d]",internal_MEMORY_OUT_PTR);
-		  
-		  // Entry flush and increase the read pointer
-		  
-		  _load_queue [internal_MEMORY_OUT_PTR]._state = LOAD_QUEUE_EMPTY;
-		  
-		  // reg_LOAD_QUEUE_PTR_READ = (reg_LOAD_QUEUE_PTR_READ+1)%_param->_size_load_queue;
-
-		  break;
-		}
-	      case SELECT_LOAD_QUEUE_SPECULATIVE :
-		{
-		  log_printf(TRACE,Load_store_unit,FUNCTION,"    * load_queue  [%d] (speculative)",internal_MEMORY_OUT_PTR);
-		  
-		  _load_queue [internal_MEMORY_OUT_PTR]._state    = LOAD_QUEUE_CHECK;
-		  // NOTE : a speculative load write in the register file.
-		  // if the speculation is a miss, write_rd is re set at 1.
-		  _load_queue [internal_MEMORY_OUT_PTR]._write_rd = 0;
-
-#ifdef STATISTICS
-                  if (usage_is_set(_usage,USE_STATISTICS))
-                    (*_stat_nb_inst_load_commit_speculative) ++;
-#endif
-
-		  break;
-		}
-
-		break;
-	      }
-	  }
-
-	//================================================================
 	// Interface "DCACHE_REQ"
 	//================================================================
@@ -943,4 +981,5 @@
 	    Tdcache_address_t address_lsb    = (address & _param->_mask_address_lsb);
 	    Tdcache_address_t check_hit_byte = gen_mask_not<Tdcache_address_t>(address_lsb+(memory_size(operation)>>3)-1,address_lsb) & _param->_mask_check_hit_byte;
+            Tlsq_ptr_t        store_queue_ptr_write = _speculative_access_queue [internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ]._store_queue_ptr_write;
 
 	    log_printf(TRACE,Load_store_unit,FUNCTION,"    * address                 : 0x%.8x", address);
@@ -955,5 +994,5 @@
 	    _load_queue [ptr_write]._packet_id             = _speculative_access_queue [internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ]._packet_id;
 	    _load_queue [ptr_write]._operation             = operation;
-	    _load_queue [ptr_write]._store_queue_ptr_write = _speculative_access_queue [internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ]._store_queue_ptr_write;
+	    _load_queue [ptr_write]._store_queue_ptr_write = store_queue_ptr_write;
 	    _load_queue [ptr_write]._address               = address;
 	    _load_queue [ptr_write]._check_hit_byte        = check_hit_byte;
@@ -964,5 +1003,4 @@
 	    // NOTE : if have an exception, must write in register, because a depend instruction wait the load data.
 	    _load_queue [ptr_write]._write_rd              = _speculative_access_queue [internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ]._write_rd             ;
-	    
 	    _load_queue [ptr_write]._num_reg_rd            = _speculative_access_queue [internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ]._num_reg_rd           ;
 	    _load_queue [ptr_write]._exception             = exception;
@@ -980,4 +1018,22 @@
               (*_stat_nb_inst_load) ++;
 #endif
+
+            // Only load need check
+            if (is_operation_memory_load(_load_queue [ptr_write]._operation))
+              {
+                log_printf(TRACE,Load_store_unit,FUNCTION,"    * update nb_check");
+                log_printf(TRACE,Load_store_unit,FUNCTION,"      *     store_queue_ptr_write : %d",store_queue_ptr_write);
+                log_printf(TRACE,Load_store_unit,FUNCTION,"      * reg_STORE_QUEUE_PTR_READ  : %d",reg_STORE_QUEUE_PTR_READ);
+                
+                uint32_t i=store_queue_ptr_write;
+                while (i!=reg_STORE_QUEUE_PTR_READ)
+                  {
+                    i=((i==0)?_param->_size_store_queue:i)-1;
+                    
+                    log_printf(TRACE,Load_store_unit,FUNCTION,"      * i                         : %d",i);
+                    
+                    reg_STORE_QUEUE_NB_CHECK [i] ++;
+                  }
+              }
           }
 
@@ -1075,5 +1131,5 @@
 	    uint32_t j = (reg_STORE_QUEUE_PTR_READ+i)%_param->_size_store_queue;
 
-            log_printf(TRACE,Load_store_unit,FUNCTION,"    [%.4d] %.4d %.4d %.4d, %.4d, %.4d, %.4d, %.8x %.8x, %.2d, %s",
+            log_printf(TRACE,Load_store_unit,FUNCTION,"    [%.4d] %.4d %.4d %.4d, %.4d, %.4d, %.4d, %.8x %.8x, %.2d, %.2d %s",
                        j,
                        _store_queue[j]._context_id          ,
@@ -1088,4 +1144,5 @@
                      //_store_queue[j]._num_reg_rd          ,
                        _store_queue[j]._exception           ,
+                       reg_STORE_QUEUE_NB_CHECK  [j]        ,
                        toString(_store_queue[j]._state).c_str());
 	  }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Parameters.cpp	(revision 117)
@@ -58,6 +58,5 @@
 
     _size_dcache_context_id                = log2(nb_context) + log2(nb_front_end) + log2(nb_ooo_engine);
-    _size_dcache_packet_id                 = (log2((size_store_queue>size_load_queue)?size_store_queue:size_load_queue))+1;
-
+    _size_dcache_packet_id                 = log2((size_store_queue>size_load_queue)?size_store_queue:size_load_queue)+1;
     _have_port_dcache_context_id           = _size_dcache_context_id>0;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Types.h	(revision 117)
@@ -121,12 +121,14 @@
       _immediat              = x._immediat     ;
       _read_ra               = x._read_ra      ;
-      _read_ra_val           = x._read_ra == 1 ; //if not must read, the registerFile is already access
+      _read_ra_val           = ((x._read_ra == 1) and (x._num_reg_ra != 0)); //if not must read, the registerFile is already access
       _num_reg_ra            = x._num_reg_ra   ;
-      _data_ra_val           = ((x._read_ra == 0) or (x._num_reg_ra == 0)); //if not must read, the data is already valid
+//    _data_ra_val           = ((x._read_ra == 0) or  (x._num_reg_ra == 0)); //if not must read, the data is already valid
+      _data_ra_val           = not _read_ra_val;
       _data_ra               = 0               ;
       _read_rb               = x._read_rb      ;
-      _read_rb_val           = x._read_rb == 1 ;
+      _read_rb_val           = ((x._read_rb == 1) and (x._num_reg_rb != 0));
       _num_reg_rb            = x._num_reg_rb   ;
-      _data_rb_val           = ((x._read_rb == 0) or (x._num_reg_rb == 0));
+//    _data_rb_val           = ((x._read_rb == 0) or  (x._num_reg_rb == 0));
+      _data_rb_val           = not _read_rb_val;
       _data_rb               = 0               ;
       _read_rc               = x._read_rc      ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_genMoore.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_genMoore.cpp	(revision 117)
@@ -100,5 +100,7 @@
       internal_WRITE_QUEUE_OUT_VAL = ((not _queue->empty()           ) and
 				      (not _queue->front()->_write_rd) and
-				      (not _queue->front()->_write_re));
+				      (not _queue->front()->_write_re) and
+                                      (_queue->front()->_exception != EXCEPTION_MEMORY_LOAD_SPECULATIVE)
+                                      );
       
       PORT_WRITE(out_WRITE_QUEUE_OUT_VAL, internal_WRITE_QUEUE_OUT_VAL);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Read_unit_to_Execution_unit/src/Read_unit_to_Execution_unit_genMealy.cpp	(revision 117)
@@ -22,5 +22,6 @@
   void Read_unit_to_Execution_unit::genMealy (void)
   {
-    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"Begin");
+    log_begin(Read_unit_to_Execution_unit,FUNCTION);
+    log_function(Read_unit_to_Execution_unit,FUNCTION,_name.c_str());
 
     bool execute_unit_use [_param->_nb_execute_unit][_param->_max_nb_execute_unit_port];
@@ -35,9 +36,9 @@
 	  bool       ack = false;
 	  
-	  log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"Test Read_unit[%d][%d]",i,j);
+	  log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"  * Test Read_unit[%d][%d]",i,j);
 	  
 	  if (PORT_READ(in_READ_UNIT_OUT_VAL [i][j]) == true)
 	    {
-	      log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION," * have a valid entry.");
+              log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"    * have a valid entry.");
 	      
 	      Tcontext_t context_id    = (_param->_have_port_context_id   )?PORT_READ(in_READ_UNIT_OUT_CONTEXT_ID    [i][j]):0;
@@ -51,5 +52,5 @@
 #ifdef DEBUG_TEST
 	      if (_destination[i][num_thread][type].empty())
-		throw ERRORMORPHEO(FUNCTION,"Invalid Operation : They have no execute_unit to receive a operation from the read_unit ["+toString(i)+"], thread ["+toString(num_thread)+"] and a operation's type ["+toString(type)+"].");
+                throw ERRORMORPHEO(FUNCTION,toString(_("Invalid Operation : They have no execute_unit to receive a operation from the read_unit [%d], thread [%d] and a operation's type [%s]."),i,num_thread,toString(type).c_str()));
 #endif
 	      
@@ -62,9 +63,9 @@
 		  uint32_t port = (*it).elt;
 		  
-		  log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"   * Test destination [%d][%d].",dest,port);
+		  log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"      * Test destination [%d][%d].",dest,port);
 		  
 		  if (execute_unit_use [dest][port] == false)
 		    {
-		      log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"     * Is ok! Link.");
+                      log_printf(TRACE,Read_unit_to_Execution_unit,FUNCTION,"        * Is ok! Link.");
 		      
 		      // have find !!!
@@ -104,5 +105,5 @@
 	PORT_WRITE(out_EXECUTE_UNIT_IN_VAL[i][j], execute_unit_use[i][j]);
 
-    log_printf(FUNC,Read_unit_to_Execution_unit,FUNCTION,"End");
+    log_end(Read_unit_to_Execution_unit,FUNCTION);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 117)
@@ -531,6 +531,10 @@
       }
 
-    _have_port_dcache_context_id = (_max_size_dcache_context_id>1);
-
+//     log_printf(TRACE,Load_store_unit,FUNCTION,"kane : size_dcache_context_id      : %d",_max_size_dcache_context_id     );
+//     log_printf(TRACE,Load_store_unit,FUNCTION,"kane : size_dcache_packet_id       : %d",_max_size_dcache_packet_id      );
+
+    _have_port_dcache_context_id = (_max_size_dcache_context_id>0);
+
+//     log_printf(TRACE,Load_store_unit,FUNCTION,"kane : have_port_dcache_context_id : %d",_have_port_dcache_context_id);
 
     if (is_toplevel)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 117)
@@ -352,10 +352,12 @@
               log_printf(TRACE,Context_State,FUNCTION,"  * BRANCH_COMPLETE [%d]",i);
 
-              context_state_t state = reg_STATE [i];
+              Tcontext_t context_id = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+
+              context_state_t state = reg_STATE [context_id];
 
               Tdepth_t   depth      = (_param->_have_port_depth)?PORT_READ(in_BRANCH_COMPLETE_DEPTH [i]):0;
-              Tdepth_t   depth_cur  = reg_EVENT_DEPTH [i];
-              Tdepth_t   depth_min  = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [i]):0;
-              Tdepth_t   depth_max  = _param->_nb_inst_branch_speculated [i];
+              Tdepth_t   depth_cur  = reg_EVENT_DEPTH [context_id];
+              Tdepth_t   depth_min  = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [context_id]):0;
+              Tdepth_t   depth_max  = _param->_nb_inst_branch_speculated [context_id];
               
               Tdepth_t   depth0     = (depth_cur>=depth_min)?(depth_cur-depth_min):((depth_cur+depth_max-depth_min));
@@ -375,4 +377,5 @@
                                        ((depth1==depth0) and (priority1>=priority0))); // >= because another branch can be a miss prediction with same depth
 
+              log_printf(TRACE,Context_State,FUNCTION,"    * context_id: %d",context_id);
               log_printf(TRACE,Context_State,FUNCTION,"    * depth     : %d",depth     );
               log_printf(TRACE,Context_State,FUNCTION,"    * depth_cur : %d",depth_cur );
@@ -387,7 +390,7 @@
               if (is_valid)
                 {
-//                reg_STATE                  [i] =  CONTEXT_STATE_KO_MISS_BRANCH_ADDR;
-                  reg_STATE                  [i] =  CONTEXT_STATE_KO_MISS_BRANCH_WAIT_UPDATE;
-                  reg_EVENT_DEPTH            [i] =  depth;
+//                reg_STATE                  [context_id] =  CONTEXT_STATE_KO_MISS_BRANCH_ADDR;
+                  reg_STATE                  [context_id] =  CONTEXT_STATE_KO_MISS_BRANCH_WAIT_UPDATE;
+                  reg_EVENT_DEPTH            [context_id] =  depth;
                 }
             }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/Instruction/src/Instruction.cpp	(revision 117)
@@ -24,6 +24,6 @@
 namespace decod {
 
-#define EXTENDS(x,nb_bits) extend<Tgeneral_data_t>(32, x,true ,nb_bits)
-#define EXTENDZ(x,nb_bits) extend<Tgeneral_data_t>(32, x,false,nb_bits)
+#define EXTENDS(x,nb_bits) extend<Tgeneral_data_t>(param->_size_data, x,true ,nb_bits)
+#define EXTENDZ(x,nb_bits) extend<Tgeneral_data_t>(param->_size_data, x,false,nb_bits)
 
   void instruction_decod               (decod_instruction_t * inst, decod_param_t * param)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/test.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/SelfTest/src/test.cpp	(revision 117)
@@ -52,4 +52,76 @@
   sc_clock              *  in_CLOCK  = new sc_clock ("clock", 1.0, 0.5);	 
   sc_signal<Tcontrol_t> *  in_NRESET = new sc_signal<Tcontrol_t> ("NRESET");
+
+  sc_signal<Tcontrol_t         > ***  in_IFETCH_VAL                         ;
+  sc_signal<Tcontrol_t         > *** out_IFETCH_ACK                         ;
+  sc_signal<Tinstruction_t     > ***  in_IFETCH_INSTRUCTION                 ;
+
+  sc_signal<Tcontext_t         >  **  in_IFETCH_CONTEXT_ID                  ;
+  sc_signal<Tgeneral_address_t >  **  in_IFETCH_ADDRESS                     ;
+//sc_signal<Tgeneral_address_t >  **  in_IFETCH_ADDRESS_NEXT                ;
+  sc_signal<Tinst_ifetch_ptr_t >  **  in_IFETCH_INST_IFETCH_PTR             ;
+  sc_signal<Tbranch_state_t    >  **  in_IFETCH_BRANCH_STATE                ;
+  sc_signal<Tprediction_ptr_t  >  **  in_IFETCH_BRANCH_UPDATE_PREDICTION_ID ;
+  sc_signal<Texception_t       >  **  in_IFETCH_EXCEPTION                   ;
+
+  sc_signal<Tcontrol_t         >  ** out_DECOD_VAL                          ;
+  sc_signal<Tcontrol_t         >  **  in_DECOD_ACK                          ;
+  sc_signal<Tcontext_t         >  ** out_DECOD_CONTEXT_ID                   ;
+  sc_signal<Tdepth_t           >  ** out_DECOD_DEPTH                        ;
+  sc_signal<Ttype_t            >  ** out_DECOD_TYPE                         ;
+  sc_signal<Toperation_t       >  ** out_DECOD_OPERATION                    ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_NO_EXECUTE                   ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_IS_DELAY_SLOT                ;
+  sc_signal<Tgeneral_data_t    >  ** out_DECOD_ADDRESS                      ;
+
+  sc_signal<Tgeneral_data_t    >  ** out_DECOD_ADDRESS_NEXT                 ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_HAS_IMMEDIAT                 ;
+  sc_signal<Tgeneral_data_t    >  ** out_DECOD_IMMEDIAT                     ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_READ_RA                      ;
+  sc_signal<Tgeneral_address_t >  ** out_DECOD_NUM_REG_RA                   ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_READ_RB                      ;
+  sc_signal<Tgeneral_address_t >  ** out_DECOD_NUM_REG_RB                   ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_READ_RC                      ;
+  sc_signal<Tspecial_address_t >  ** out_DECOD_NUM_REG_RC                   ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_WRITE_RD                     ;
+  sc_signal<Tgeneral_address_t >  ** out_DECOD_NUM_REG_RD                   ;
+  sc_signal<Tcontrol_t         >  ** out_DECOD_WRITE_RE                     ;
+  sc_signal<Tspecial_address_t >  ** out_DECOD_NUM_REG_RE                   ;
+  sc_signal<Texception_t       >  ** out_DECOD_EXCEPTION_USE                ;
+  sc_signal<Texception_t       >  ** out_DECOD_EXCEPTION                    ;
+
+  sc_signal<Tcontrol_t         >  ** out_PREDICT_VAL                        ;
+  sc_signal<Tcontrol_t         >  **  in_PREDICT_ACK                        ;
+  sc_signal<Tcontext_t         >  ** out_PREDICT_CONTEXT_ID                 ;
+  sc_signal<Tcontrol_t         >  ** out_PREDICT_MATCH_INST_IFETCH_PTR      ;
+  sc_signal<Tbranch_state_t    >  ** out_PREDICT_BRANCH_STATE               ;
+  sc_signal<Tprediction_ptr_t  >  ** out_PREDICT_BRANCH_UPDATE_PREDICTION_ID;
+  sc_signal<Tbranch_condition_t>  ** out_PREDICT_BRANCH_CONDITION           ;
+//sc_signal<Tcontrol_t         >  ** out_PREDICT_BRANCH_STACK_WRITE         ;
+  sc_signal<Tcontrol_t         >  ** out_PREDICT_BRANCH_DIRECTION           ;
+  sc_signal<Tgeneral_data_t    >  ** out_PREDICT_ADDRESS_SRC                ;
+  sc_signal<Tgeneral_data_t    >  ** out_PREDICT_ADDRESS_DEST               ;
+  sc_signal<Tcontrol_t         >  **  in_PREDICT_CAN_CONTINUE               ;
+
+  sc_signal<Tdepth_t           >  **  in_DEPTH_MIN                          ;
+  sc_signal<Tdepth_t           >  **  in_DEPTH_MAX                          ;
+  sc_signal<Tcontrol_t         >  **  in_DEPTH_FULL                         ;
+
+  sc_signal<Tcounter_t         >  ** out_NB_INST_DECOD_ALL                  ;
+
+  sc_signal<Tcontrol_t         >  **  in_CONTEXT_DECOD_ENABLE               ;
+  sc_signal<Tcontrol_t         >  **  in_CONTEXT_DEPTH_VAL                  ;
+  sc_signal<Tdepth_t           >  **  in_CONTEXT_DEPTH                      ;
+
+  sc_signal<Tcontrol_t         >   * out_CONTEXT_EVENT_VAL                  ;
+  sc_signal<Tcontrol_t         >   *  in_CONTEXT_EVENT_ACK                  ;
+  sc_signal<Tcontext_t         >   * out_CONTEXT_EVENT_CONTEXT_ID           ;
+  sc_signal<Tdepth_t           >   * out_CONTEXT_EVENT_DEPTH                ;
+  sc_signal<Tevent_type_t      >   * out_CONTEXT_EVENT_TYPE                 ;
+  sc_signal<Tcontrol_t         >   * out_CONTEXT_EVENT_IS_DELAY_SLOT        ;
+  sc_signal<Tgeneral_data_t    >   * out_CONTEXT_EVENT_ADDRESS              ;
+  sc_signal<Tgeneral_data_t    >   * out_CONTEXT_EVENT_ADDRESS_EPCR         ;
+
+
 
   ALLOC2_SC_SIGNAL( in_IFETCH_VAL                         ," in_IFETCH_VAL                         ",Tcontrol_t         ,_param->_nb_context, _param->_nb_inst_fetch[it1]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_allocation.cpp	(revision 117)
@@ -242,9 +242,11 @@
 
 #if defined(DEBUG) and defined(DEBUG_Update_Prediction_Table) and (DEBUG_Update_Prediction_Table == true)
+    directory_init ();
+
     branchement_log_file = new std::ofstream [_param->_nb_thread];
     for (uint32_t i=0; i<_param->_nb_thread; ++i)
       if (_param->_have_thread [i])
         {
-          std::string filename = "Branchement_prediction-thread_" + toString(i) + ".log";
+          std::string filename = MORPHEO_LOG+"/"+toString(getpid())+"-Branchement_prediction-thread_"+toString(i)+".log";
           
           branchement_log_file [i] .open(filename.c_str() ,std::ios::out | std::ios::trunc);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h	(revision 117)
@@ -60,6 +60,10 @@
   public : uint32_t         ** _array_size_depth        ;//[nb_front_end][nb_context]
 //public : uint32_t            _max_size_depth          ;
-  public : Tpacket_t           _shift_num_bank          ;
-  public : Tpacket_t           _mask_size_bank          ;
+
+//public : Tpacket_t           _shift_num_bank          ;
+  public : Tpacket_t           _mask_num_bank           ;
+  public : Tpacket_t           _shift_num_slot          ;
+//public : Tpacket_t           _mask_num_slot           ;
+    
 
 //public : bool                _have_port_front_end_id  ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_allocation.cpp	(revision 117)
@@ -336,9 +336,11 @@
 
 #if defined(DEBUG) and defined(DEBUG_Commit_unit) and (DEBUG_Commit_unit == true)
+    directory_init ();
+
     instruction_log_file = new std::ofstream [_param->_nb_thread];
     for (uint32_t i=0; i<_param->_nb_thread; ++i)
       if (_param->_have_thread [i])
         {
-          std::string filename = "Instruction_flow-thread_" + toString(i) + ".log";
+          std::string filename = MORPHEO_LOG+"/"+toString(getpid())+"-Instruction_flow-thread_"+toString(i)+"-"+toString(getpid())+".log";
           
           instruction_log_file [i] .open(filename.c_str() ,std::ios::out | std::ios::trunc);
